#version 300 es
precision highp float;
precision highp int;

uniform vec2 _Offset;
uniform vec2 _Tiling;
uniform float _Rotation;
uniform mediump sampler2D _BaseTexture;
uniform vec4 _BaseColor;
uniform mediump sampler2D _OpacityTexture;
uniform vec4 u_WorldSpaceCameraPos;

in vec2 g_vary_uv0;
layout(location = 0) out vec4 o_fragColor;
in vec4 v_sampling_pos;
in vec4 v_background_pos;
in vec3 v_worldPos;
in vec3 v_Normal;

vec2 UV_TRS(vec2 inputUV, vec2 uvCenter, vec2 uvPan, vec2 uvScale, float uvRotate)
{
    vec2 minusCenterUV = inputUV - uvCenter;
    float cosVal = cos(uvRotate);
    float sinVal = sin(uvRotate);
    mat2 rotateMat = mat2(vec2(cosVal, -sinVal), vec2(sinVal, cosVal));
    vec2 outputUV = minusCenterUV * uvScale;
    outputUV = (rotateMat * outputUV) + uvCenter;
    outputUV += uvPan;
    return outputUV;
}

void main()
{
    vec2 uv = g_vary_uv0;
    uv.y = 1.0 - uv.y;
    vec2 param = uv;
    vec2 param_1 = vec2(0.5);
    vec2 param_2 = _Offset;
    vec2 param_3 = _Tiling;
    float param_4 = _Rotation * 0.01745329238474369049072265625;
    uv = UV_TRS(param, param_1, param_2, param_3, param_4);
    vec4 texColor = texture(_BaseTexture, uv) * _BaseColor;
    vec3 _106 = texColor.xyz / vec3(texColor.w);
    texColor = vec4(_106.x, _106.y, _106.z, texColor.w);
    vec4 t_OpacityTex = texture(_OpacityTexture, uv);
    texColor.w *= t_OpacityTex.x;
    o_fragColor = texColor;
}

