#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

struct buffer_t
{
    float2 _Offset;
    float2 _Tiling;
    float _Rotation;
    float4 _BaseColor;
};

struct main0_out
{
    float4 o_fragColor [[color(0)]];
};

struct main0_in
{
    float2 g_vary_uv0;
};

static inline __attribute__((always_inline))
float2 UV_TRS(thread const float2& inputUV, thread const float2& uvCenter, thread const float2& uvPan, thread const float2& uvScale, thread const float& uvRotate)
{
    float2 minusCenterUV = inputUV - uvCenter;
    float cosVal = cos(uvRotate);
    float sinVal = sin(uvRotate);
    float2x2 rotateMat = float2x2(float2(cosVal, -sinVal), float2(sinVal, cosVal));
    float2 outputUV = minusCenterUV * uvScale;
    outputUV = (rotateMat * outputUV) + uvCenter;
    outputUV += uvPan;
    return outputUV;
}

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer, texture2d<float> _BaseTexture [[texture(0)]], texture2d<float> _OpacityTexture [[texture(1)]], sampler _BaseTextureSmplr [[sampler(0)]], sampler _OpacityTextureSmplr [[sampler(1)]])
{
    main0_out out = {};
    float2 uv = in.g_vary_uv0;
    uv.y = 1.0 - uv.y;
    float2 param = uv;
    float2 param_1 = float2(0.5);
    float2 param_2 = buffer._Offset;
    float2 param_3 = buffer._Tiling;
    float param_4 = buffer._Rotation * 0.01745329238474369049072265625;
    uv = UV_TRS(param, param_1, param_2, param_3, param_4);
    float4 texColor = _BaseTexture.sample(_BaseTextureSmplr, uv) * buffer._BaseColor;
    float3 _106 = texColor.xyz / float3(texColor.w);
    texColor = float4(_106.x, _106.y, _106.z, texColor.w);
    float4 t_OpacityTex = _OpacityTexture.sample(_OpacityTextureSmplr, uv);
    texColor.w *= t_OpacityTex.x;
    out.o_fragColor = texColor;
    return out;
}

