#version 300 es

uniform mat4 u_Palatte[50];
uniform mat4 u_Model;
uniform mat4 u_TransposeInvModel;
uniform mat4 u_MVP;
uniform vec2 _Offset;
uniform vec2 _Tiling;
uniform float _Rotation;
uniform mat4 u_InvModel;
uniform vec4 u_Time;
uniform vec4 u_WorldSpaceCameraPos;
uniform vec4 u_ScreenParams;

layout(location = 1) in vec3 attNormal;
layout(location = 3) in vec3 attTangent;
layout(location = 4) in vec4 attBoneIds;
layout(location = 5) in vec4 attWeights;
layout(location = 0) in vec3 attPosition;
out vec3 v_posWS;
out vec3 v_nDirWS;
out vec3 v_tDirWS;
out vec3 v_bDirWS;
out vec2 v_uv0;
layout(location = 2) in vec2 attTexcoord0;
out vec4 v_gl_pos;

vec2 UV_TRS(vec2 inputUV, vec2 uvCenter, vec2 uvPan, vec2 uvScale, float uvRotate)
{
    vec2 minusCenterUV = inputUV - uvCenter;
    float cosVal = cos(uvRotate);
    float sinVal = sin(uvRotate);
    mat2 rotateMat = mat2(vec2(cosVal, -sinVal), vec2(sinVal, cosVal));
    vec2 outputUV = minusCenterUV * uvScale;
    outputUV = (rotateMat * outputUV) + uvCenter;
    outputUV += uvPan;
    return outputUV;
}

void main()
{
    vec3 attBinormal = normalize(cross(attNormal, attTangent));
    mat4 _89 = u_Palatte[int(attBoneIds.x)] * attWeights.x;
    mat4 _98 = u_Palatte[int(attBoneIds.y)] * attWeights.y;
    mat4 _111 = mat4(_89[0] + _98[0], _89[1] + _98[1], _89[2] + _98[2], _89[3] + _98[3]);
    mat4 _120 = u_Palatte[int(attBoneIds.z)] * attWeights.z;
    mat4 _133 = mat4(_111[0] + _120[0], _111[1] + _120[1], _111[2] + _120[2], _111[3] + _120[3]);
    mat4 _142 = u_Palatte[int(attBoneIds.w)] * attWeights.w;
    mat4 boneTransform = mat4(_133[0] + _142[0], _133[1] + _142[1], _133[2] + _142[2], _133[3] + _142[3]);
    vec3 bm_postiton = (boneTransform * vec4(attPosition, 1.0)).xyz;
    vec3 bn_normal = (boneTransform * vec4(attNormal, 0.0)).xyz;
    v_posWS = (u_Model * vec4(bm_postiton, 1.0)).xyz;
    v_nDirWS = normalize((u_TransposeInvModel * vec4(bn_normal, 0.0)).xyz);
    vec3 bm_tangent = (boneTransform * vec4(attTangent, 0.0)).xyz;
    vec3 bm_binormal = (boneTransform * vec4(attBinormal, 0.0)).xyz;
    v_tDirWS = normalize((u_Model * vec4(bm_tangent, 0.0)).xyz);
    v_bDirWS = normalize((u_Model * vec4(bm_binormal, 0.0)).xyz);
    gl_Position = (u_MVP * boneTransform) * vec4(attPosition, 1.0);
    v_uv0 = vec2(attTexcoord0.x, 1.0 - attTexcoord0.y);
    vec2 param = v_uv0;
    vec2 param_1 = vec2(0.5);
    vec2 param_2 = _Offset;
    vec2 param_3 = _Tiling;
    float param_4 = _Rotation / 57.295780181884765625;
    v_uv0 = UV_TRS(param, param_1, param_2, param_3, param_4);
    v_gl_pos = gl_Position;
}

